uses struvyk;
var
  MM,NN:integer;
  NSTL:integer;
  stl,ii,jj,kk,ll:integer;
  nazvy: array[1..15] of string;
  sumar: vykaz;
  pokyny: array[1..200] of integer;
  rr,ss: array[1..50] of integer;
  vstup:text;
  veta:array[1..20] of integer;
  o:TabOp;

  procedure initab;
  var i,j:integer;
  begin
     {inicializacia vykazu}
     with sumar do begin
        pcas:=3;
        stru[1,1]:=3; stru[1,2]:=6;
        stru[2,1]:=3; stru[2,2]:=6;
        stru[3,1]:=3; stru[3,2]:=4;
     end;
     DoplnTab(sumar);
        MM:=sumar.stru[sumar.pcas+1,4]; NN:=sumar.stru[sumar.pcas+1,5];
        writeln('MM=',MM,' NN=', NN);
     for i:=1 to sumar.stru[sumar.pcas+1,3] do begin
         sumar.cisla[i]:=0;
         pokyny[i]:=0;
     end;
     writeln;
     writeln('Tabulka struktury vykazu'); writeln;
     for i:=1 to sumar.pcas do begin
        write(i:5);
        for j:=1 to 5 do write(sumar.stru[i,j]:5); writeln;
     end;
  end;

  procedure DajPokyn(vyk:vykaz; i,j,k: integer);
      var n:integer;
      begin
         TabToLin(vyk,i,j,n);
         pokyny[n]:=k;
      end;

  procedure IniPok;
    var i,j,k,l:integer;
    begin
       for i:=1 to 3 do
         for j:=1 to 6 do case j of
         1,3,5: DajPokyn(sumar,i,j,-1);
         2,4,6: DajPokyn(sumar,i,j,3);
         end;
       for i:=4 to 5 do
         for j:=7 to 8 do case j of
         7: DajPokyn(sumar,i,j,-1);
         8:DajPokyn(sumar,i,j,2);
         end;
         writeln;

         writeln('Tabulka pokynov');
         writeln;
         with sumar do begin
             for k:=1 to pcas do begin
                 writeln; writeln('Cast',k:5);
                 write(' ':5);
                 for j:=1 to stru[k,2] do write(j:5); writeln;
                 for i:=1 to stru[k,1] do begin
                    write(i:5);
                    for j:=1 to stru[k,2] do begin
                       CastToLin(sumar,k,i,j,l);
                       write(pokyny[l]:5);
                    end;
                    writeln;
                 end;
              end;
           end;
         end;

  procedure IniOp;
      begin
         with o do begin
            Nop:=1;
            with Instr[1] do begin
              c1:=2;
              r1:=3;
              s1:=1;
              k11:=1; m11:=0; s11:=0;
              k12:=2; m12:=0; s12:=1;
              ko:=1;
              c2:=2;
              r2:=1;
              s2:=1;
              k21:=1; m21:=0; s21:=6;
              k22:=2; m22:=0; s22:=-11;
              cv:=2;
              rv:=3;
              sv:=1;
              kv1:=1; mv1:=0; sv1:=0;
              kv2:=2; mv2:=0; sv2:=1;
              nkr:=4;
            end;

         end;
         RedOp(sumar,o);
      end;

  procedure VypOp(q:oper);
     var xx:string;
     begin
        xx:='+-*/%';
        with q do begin
           write(' [',c1:3,r1:3,s1:3,'] ');
           write(xx[ko]);
           write(' [',c2:3,r2:3,s2:3,'] ');
           write('=>');
           write(' [',cv:3,rv:3,sv:3,'] ');
           writeln(nkr:5);
           write(' (',k11:3,m11:3,s11:3,')');
           write(' ':3);
           write(' (',k21:3,m21:3,s21:3,')');
           write(' ':4);
           write(' (',kv1:3,mv1:3,sv1:3,')');
           writeln;
           write(' (',k12:3,m12:3,s12:3,')');
           write(' ':4);
           write(' (',k22:3,m22:3,s22:3,')');
           write(' ':5);
           write(' (',kv2:3,mv2:3,sv2:3,')');
           writeln;
        end;
     end;

     procedure VypTab(h:TabOp);
        var jj:integer;
        begin
           writeln(' Tabulka operacii'); writeln;
           with h do begin
               for jj:=1 to Nop do begin
                  writeln('Operacia c.',jj:3);
                  VypOp(Instr[jj]);
               end;
           end;
        end;

  procedure Obsad;
     var i:integer;
     begin
       for i:=1 to 50 do begin rr[i]:=0; ss[i]:=0; end;
       case veta[1] of
       1: begin rr[1]:=1; rr[3]:=1; rr[4]:=1; end;
       2: begin rr[2]:=1; rr[3]:=1; rr[5]:=1; end;
       end;
       if veta[2]>25 then begin ss[1]:=1; ss[2]:=1; ss[5]:=1; ss[6]:=1 end
                 else begin ss[3]:=1; ss[4]:=1; ss[5]:=1; ss[6]:=1 end;
        ss[7]:=1; ss[8]:=1
     end;

   procedure nacitaj;
       var i,j,kk:integer;
       begin
          for i:=1 to MM do begin
            for j:=1 to NN do begin
                TabToLin(sumar,i,j,kk);
                if kk>0 then begin
                  if rr[i]*ss[j]<>0 then
                    if pokyny[kk]<0 then sumar.cisla[kk]:=sumar.cisla[kk]+1
                     else if pokyny[kk]>0 then sumar.cisla[kk]:=sumar.cisla[kk]+
                            veta[pokyny[kk]];
                end;
            end;
          end;
       end;

  procedure vypis;
     var i,j,k,l:integer;
     begin
         writeln; writeln('Vykaz po sumarizacii'); writeln;
         with sumar do begin
             for k:=1 to pcas do begin
                 writeln; writeln('Cast',k:5);
                 write(' ':8);
                 for j:=1 to stru[k,2] do write(j:8); writeln;
                 for i:=1 to stru[k,1] do begin
                    write(i:8);
                    for j:=1 to stru[k,2] do begin
                       CastToLin(sumar,k,i,j,l);
                       write(cisla[l]:8:0);
                    end;
                    writeln;
                 end;
              end;
           end;
         end;


  begin
     initab;
     inipok;
     IniOp;
     VypTab(o);
     assign(vstup,'detail.in');
     reset(vstup);
     writeln;
     writeln('Vstupne data'); writeln;
     readln(vstup,NSTL);
     for stl:=1 to NSTL do begin
       readln(vstup, nazvy[stl]);
       write(nazvy[stl]:10);
     end;
     writeln;
     read(vstup,veta[1]);
     while veta[1]<>0 do begin
       write(veta[1]:10);
       for stl:=2 to NSTL do begin
          read(vstup,veta[stl]);
          write(veta[stl]:10);
        end;
        writeln;
        obsad;
        nacitaj;
        read(vstup,veta[1]);
     end;
     close(vstup);
     vypis;
     Zmakni(o,sumar);
     vypis;
     readln;
   end.